unit ReadRGBBox;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, CoolForm, StdCtrls, OwnerButton,VideoCapture,CommonUnit,
  Counter;

type
  TReadRGBForm = class(TForm)
    CloseButton: TOwnerButton;
    Panel1: TPanel;
    CoolForm1: TCoolForm;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    REDCounter: TCounter;
    GreenCounter: TCounter;
    BlueCounter: TCounter;
    CompCounter: TCounter;
    Image1: TImage;
    procedure CloseButtonClick(Sender: TObject);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

  private
    { Private declarations }
//    fVideoCapture:TVideoCapture;
  public
    { Public declarations }
  end;

var
  ReadRGBForm: TReadRGBForm;

  Procedure ShowReadRGBBox(aVideoBox:TVideoCapture);


implementation

{$R *.dfm}

Procedure ShowReadRGBBox(aVideoBox:TVideoCapture);
begin


  ReadRGBForm:= TReadRGBForm.Create(nil);


  with ReadRGBForm do
  begin
    Image1.Picture.Bitmap.Width :=aVideoBox.Width;
    Image1.Picture.Bitmap.Height:=aVideoBox.Height;
    Image1.Picture.Bitmap.PixelFormat:=pf16bit;
    aVideoBox.GetBitmap(Image1.Picture.Bitmap);
  end;


  ReadRGBForm.ShowModal;

  ReadRGBForm.Free;
end;




procedure TReadRGBForm.CloseButtonClick(Sender: TObject);
begin
 Close;
end;

procedure TReadRGBForm.Panel1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
c:WORD;
c1:TVCPColor;
p:PByteArray;
p2:PWordArray;
begin

 p:=Image1.Picture.Bitmap.ScanLine[Y];
 integer(p2):=integer(p)+x*2;

 c:=p2[0];

 c1.RED  :=(c and $f800) shr 11;
 c1.GREEN:=(c and $07e0) shr 6;
 c1.BLUE :=(c and $001f);

 with c1 do
 begin
 COMPOUND:= integer(RED+GREEN+BLUE) div 3
 end;

 REDCounter.Value  := c1.RED   ;
 GreenCounter.Value:= c1.GREEN ;
 BlueCounter.Value := c1.BLUE  ;
 CompCounter.Value := c1.COMPOUND;

end;

end.
