unit VCapDescription;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,VideoCapture,VFW_SDK ,StdCtrls;

type
  TVCapDescriptionForm = class(TForm)
    CaptureDescriptionBox: TStaticText;
    CloseButton: TButton;
    procedure CloseButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  VCapDescriptionForm: TVCapDescriptionForm;


  Procedure ShowVideoCaptureDescription(aVideoBox: TVideoCapture);

implementation

{$R *.dfm}

Procedure ShowVideoCaptureDescription(aVideoBox: TVideoCapture);
var
 caps:PCapDriverCaps;
 s:string;
begin

 caps:=aVideoBox.ReadDescription;



 s:='Driver index='+inttostr(caps^.wDeviceIndex)+#10+#13;
 s:=s+'Can device overlay=';
  if caps^.fHasOverlay then  s:=s+'TRUE'
  else                       s:=s+'FALSE';
 s:=s+#10+#13;

 s:=s+'Has Video source dlg=';
 if  caps^.fHasDlgVideoSource  then s:=s+'TRUE'
 else                               s:=s+'FALSE';
 s:=s+#10+#13;

 s:=s+'Can device overlay=';
  if caps^.fHasOverlay then  s:=s+'TRUE'
  else                       s:=s+'FALSE';
 s:=s+#10+#13;

 s:=s+'Has Format dlg=';
 if   caps^.fHasDlgVideoFormat   then s:=s+'TRUE'
 else                                 s:=s+'FALSE';
 s:=s+#10+#13;

 s:=s+'Has External out dlg=';
 if    caps^.fHasDlgVideoDisplay  then s:=s+'TRUE'
 else                                  s:=s+'FALSE';
 s:=s+#10+#13;

 s:=s+'Driver ready to capture=';
 if    caps^.fCaptureInitialized   then s:=s+'TRUE'
 else                                   s:=s+'FALSE';
 s:=s+#10+#13;

 s:=s+'Can driver make palettes=';
 if  caps^.fDriverSuppliesPalettes  then s:=s+'TRUE'
 else                                    s:=s+'FALSE';
 s:=s+#10+#13;

 s:=s+'Driver In channel=';
 if  caps^.hVideoIn<>0  then s:=s+'TRUE'
 else                        s:=s+'FALSE';
 s:=s+#10+#13;

 s:=s+'Driver Out channel=';
 if  caps^.hVideoOut<>0  then s:=s+'TRUE'
 else                         s:=s+'FALSE';
 s:=s+#10+#13;

 s:=s+'Driver Ext In channel=';
 if  caps^.hVideoExtIn<>0  then s:=s+'TRUE'
 else                           s:=s+'FALSE';
 s:=s+#10+#13;

 s:=s+'Driver Ext Out channel=';
 if  caps^.hVideoExtOut <>0  then s:=s+'TRUE'
 else                           s:=s+'FALSE';

 VCapDescriptionForm:=TVCapDescriptionForm.Create(nil);
 VCapDescriptionForm.CaptureDescriptionBox.Caption:=s;
 VCapDescriptionForm.ShowModal;
 VCapDescriptionForm.Free;

end;


procedure TVCapDescriptionForm.CloseButtonClick(Sender: TObject);
begin
 Close;
end;

end.
